<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;
use Mattiverse\Userstamps\Traits\Userstamps;
use OwenIt\Auditing\Contracts\Auditable;

class Denuncia extends Model implements Auditable
{
    use SoftDeletes, Userstamps;
    use \OwenIt\Auditing\Auditable;

    protected $fillable = [
        'codigo',
        'user_id',
        'tipo_denuncia',
        'es_anonima',
        'es_reserva',
        'nombres',
        'apellido_paterno',
        'apellido_materno',
        'sexo',
        'direccion_domicilio',
        'departamento_residencia',
        'tipo_documento',
        'numero_documento',
        'lugar_emision',
        'correo_electronico',
        'numero_celular',
        'relato_hechos',
        'presento_otra_instancia',
        'institucion_otra_instancia',
        'fecha_presentacion_otra_instancia',
        'estado_actual','created_by',
        'updated_by',
        'deleted_by',
    ];

    protected $casts = [
        'es_anonima' => 'boolean',
        'es_reserva' => 'boolean',
        'presento_otra_instancia' => 'boolean',
        'fecha_presentacion_otra_instancia' => 'date',
    ];

    public function user()
    {
        return $this->belongsTo(User::class);
    }

    public function denunciados()
    {
        return $this->hasMany(Denunciado::class);
    }

    public function seguimientos()
    {
        return $this->hasMany(DenunciaSeguimiento::class);
    }

    public function pruebas()
    {
        return $this->hasMany(DenunciaPrueba::class);
    }
}